#lang errortrace racket
(require "hw5-util.rkt")
#|
(parse-frame
    '[ E10 (a . 10)
       (b . (closure E0 (lambda (y) a)))])
|#
;-----------------


(struct frame (parent vars) #:transparent)

(define empty-frame (frame #f (hash)))
; Print an empty frame
; empty-frame

(define e0-frame (frame #f
  (hash (d:variable 'a) (d:number 20)
        (d:variable 'b) (d:number 10))))

(define/contract (frame-put frm var val)
  (-> frame? d:variable? d:value? frame?)
  (define old-vars (frame-vars frm))
  (define new-vars (hash-set old-vars var val))
  (frame (frame-parent frm) new-vars))

(define/contract (frame-get frm var)
  (-> frame? d:variable? (or/c d:value? #f))
  (define vars (frame-vars frm))
  (hash-ref vars var #f))

(frame-get e0-frame (d:variable 'a))
(frame-get e0-frame (d:variable 'b))
(frame-get e0-frame (d:variable 'z))

(define (frame-push parent key value)
    (frame parent (hash key value)))

(frame-push #f (d:variable 'c) (d:number 30))


; (frame-put e0-frame
;   (d:variable 'c) (d:number 30))
; Bug: our code should reject this
;(frame-put e0-frame (d:number 30) (d:variable 'c))









;